2 # Copyright (c) 2007, Nanako Shiraishi
4 USAGE='[ | list | show | apply | clear]'
11 TMP="$GIT_DIR/.git-stash.$$"
12 trap 'rm -f "$TMP-*"' 0
17 git diff-index --quiet --cached HEAD &&
18 git diff-files --quiet
22 if current=$(git rev-parse --verify $ref_stash 2>/dev/null)
24 git update-ref -d $ref_stash $current
36 # state of the base commit
37 if b_commit=$(git rev-parse --verify HEAD)
39 head=$(git log --abbrev-commit --pretty=oneline -n 1 HEAD)
41 die "You do not have the initial commit yet"
44 if branch=$(git symbolic-ref -q HEAD)
46 branch=${branch#refs/heads/}
50 msg=$(printf '%s: %s' "$branch" "$head")
53 i_tree=$(git write-tree) &&
54 i_commit=$(printf 'index on %s\n' "$msg" |
55 git commit-tree $i_tree -p $b_commit) ||
56 die "Cannot save the current index state"
58 # state of the working tree
61 cp -p ${GIT_INDEX_FILE-"$GIT_DIR/index"} "$TMP-index" &&
62 GIT_INDEX_FILE="$TMP-index" &&
63 export GIT_INDEX_FILE &&
64 git read-tree -m $i_tree &&
69 die "Cannot save the current worktree state"
72 if test -z "$stash_msg"
74 stash_msg=$(printf 'WIP on %s' "$msg")
76 stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
78 w_commit=$(printf '%s\n' "$stash_msg" |
79 git commit-tree $w_tree -p $b_commit -p $i_commit) ||
80 die "Cannot record working tree state"
88 echo >&2 'No local changes to save'
91 test -f "$GIT_DIR/logs/$ref_stash" ||
92 clear_stash || die "Cannot initialize stash"
94 create_stash "$stash_msg"
96 # Make sure the reflog for stash is kept.
97 : >>"$GIT_DIR/logs/$ref_stash"
99 git update-ref -m "$stash_msg" $ref_stash $w_commit ||
100 die "Cannot save the current status"
101 printf >&2 'Saved "%s"\n' "$stash_msg"
105 git rev-parse --verify $ref_stash >/dev/null 2>&1
109 have_stash || return 0
110 git log --pretty=oneline -g "$@" $ref_stash |
111 sed -n -e 's/^[.0-9a-f]* refs\///p'
115 flags=$(git rev-parse --no-revs --flags "$@")
120 s=$(git rev-parse --revs-only --no-flags --default $ref_stash "$@")
122 w_commit=$(git rev-parse --verify "$s") &&
123 b_commit=$(git rev-parse --verify "$s^") &&
124 git diff $flags $b_commit $w_commit
128 git diff-files --quiet ||
129 die 'Cannot restore on top of a dirty state'
138 # current index state
139 c_tree=$(git write-tree) ||
140 die 'Cannot apply a stash in the middle of a merge'
142 # stash records the work tree, and is a merge between the
143 # base commit (first parent) and the index tree (second parent).
144 s=$(git rev-parse --revs-only --no-flags --default $ref_stash "$@") &&
145 w_tree=$(git rev-parse --verify "$s:") &&
146 b_tree=$(git rev-parse --verify "$s^1:") &&
147 i_tree=$(git rev-parse --verify "$s^2:") ||
148 die "$*: no valid stashed state found"
150 unstashed_index_tree=
151 if test -n "$unstash_index" && test "$b_tree" != "$i_tree"
153 git diff-tree --binary $s^2^..$s^2 | git apply --cached
155 die 'Conflicts in index. Try without --index.'
156 unstashed_index_tree=$(git-write-tree) ||
157 die 'Could not save index tree'
162 GITHEAD_$w_tree='Stashed changes' &&
163 GITHEAD_$c_tree='Updated upstream' &&
164 GITHEAD_$b_tree='Version stash was based on' &&
165 export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
168 if git-merge-recursive $b_tree -- $c_tree $w_tree
171 if test -n "$unstashed_index_tree"
173 git read-tree "$unstashed_index_tree"
176 git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
177 git read-tree --reset $c_tree &&
178 git update-index --add --stdin <"$a" ||
179 die "Cannot unstage modified files"
184 # Merge conflict; keep the exit status from merge-recursive
186 if test -n "$unstash_index"
188 echo >&2 'Index was not unstashed.'
217 if test $# -gt 0 && test "$1" = create
221 create_stash "$*" && echo "$w_commit"
227 if test $# -gt 0 && test "$1" = save
231 save_stash "$*" && git-reset --hard